/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mstrauch.test.aop;

import org.apache.log4j.Logger;
import org.jboss.aop.Aspect;
import org.jboss.aop.Bind;
import org.jboss.aop.advice.Scope;
import org.jboss.aop.joinpoint.MethodInvocation;

/**
 * <b>MyAnnoatedAspect</b><br /><br />
 *
 *
 *
 * <p><i>Copyright (c) Marabu EDV GmbH</i></p>
 *
 * @author      Marco Strauch (mst)
 * @created     01.11.2010
 * @version     6.0.0
 * @since       6.0.0
 */
@Aspect( scope = Scope.PER_INSTANCE )
public class MyAnnoatedAspect {

    private static final Logger logger = Logger.getLogger( MyAnnoatedAspect.class );

    public MyAnnoatedAspect() {
        logger.info( "<init>" );
    }

    @Bind( pointcut = "execution(* *->@mstrauch.test.aop.common.MyAnnotation())" )
    public Object injectTestAnnot01( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectTestAnnot01]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution(* *->@mstrauch.test.aop.MyAnnotation2())" )
    public Object injectTestAnnot02( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectTestAnnot02]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution(* *->@mstrauch.test.aop.MyAnnotation3())" )
    public Object injectTestAnnot03( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectTestAnnot03 --> " + invocation.getMethod().getName() + "]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution( * mstrauch.test.aop.TestClass->test11(..))" )
    public Object injectTest11( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectTest11 --> " + invocation.getMethod().getName() + "]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution( * mstrauch.test.aop.common.CommonTest->*(..))" )
    public Object injectCommonTest11( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectCommonTest11 --> " + invocation.getMethod().getName() + "]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution( * mstrauch.test.aop.TestSessionBean->*(..))" )
    public Object injectTestSessionBean( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectTestSessionBean --> " + invocation.getMethod().getName() + "]" );
        return invocation.invokeNext();

    }

    @Bind( pointcut = "execution( * mstrauch.test.aop.ITestSessionLocal->*(..))" )
    public Object injectITestSessionLocal( MethodInvocation invocation ) throws Throwable {
        logger.info( "[injectITestSessionLocal --> " + invocation.getMethod().getName() + "]" );
        return invocation.invokeNext();

    }
}
